Scala Compiler2.13.0 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  abstract class SpecializeTypes extends SubComponent with InfoTransform with TypingTransformers

  Specialize code on types.

  Specialize code on types.

  Make sure you've read the thesis:

  Iulian Dragos: Compiling Scala for Performance (chapter 4)

  There are some things worth noting, (possibly) not mentioned there: 0) Make sure you understand the meaning of various `SpecializedInfo` descriptors defined below.

  1) Specializing traits by introducing bridges in specialized methods of the specialized trait may introduce problems during mixin composition. Concretely, it may cause cyclic calls and result in a stack overflow. See ticket #4351. This was solved by introducing an `Abstract` specialized info descriptor. Instead of generating a bridge in the trait, an abstract method is generated.

  2) Specialized private members sometimes have to be switched to protected. In some cases, even this is not enough. Example:

      class A[@specialized T](protected val d: T) {
        def foo(that: A[T]) = that.d
      }

  Specialization will generate a specialized class and a specialized method:

      class A$mcI$sp(protected val d: Int) extends A[Int] {
        def foo(that: A[Int]) = foo$mcI$sp(that)
        def foo(that: A[Int]) = that.d
      }

  Above, `A$mcI$sp` cannot access `d`, so the method cannot be typechecked.

  Definition Classes
    transform
- Abstract
- Duplicator
- Forward
- Implementation
- ImplementationAdapter
- NormalizedMember
- Overload
- Phase
- SpecialOverload
- SpecialOverride
- SpecialSuperAccessor
- SpecializationDuplicator
- SpecializationPhase
- SpecializationTransformer
- SpecializedAccessor
- SpecializedInfo
- SpecializedInnerClass
- SpecializedSuperConstructorCallArgument
- StdPhase
- TypeEnv
- TypingTransformer
- UnifyError

c

scala.tools.nsc.transform.SpecializeTypes

# SpecializationTransformer

###

#### class SpecializationTransformer extends TypingTransformer

Source
  SpecializeTypes.scala

Linear Supertypes
SpecializeTypes.TypingTransformer, Global.Transformer, Global.InternalTransformer, Global.Transformer, AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. SpecializationTransformer
2. TypingTransformer
3. Transformer
4. InternalTransformer
5. Transformer
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new SpecializationTransformer(unit: Global.CompilationUnit)

### Type Members

1.  class CollectMethodBodies extends Global.InternalTraverser

   Collect method bodies that are concrete specialized methods.

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from SpecializationTransformer toany2stringadd[SpecializationTransformer] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (SpecializationTransformer, B)
   Implicit
     This member is added by an implicit conversion from SpecializationTransformer toArrowAssoc[SpecializationTransformer] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def atOwner[A](tree: Global.Tree, owner: Global.Symbol)(trans: => A): A
   Definition Classes
     TypingTransformer
8.  final def atOwner[A](owner: Global.Symbol)(trans: => A): A
   Definition Classes
     TypingTransformer → Transformer
9.  val body: AnyRefMap[Global.Symbol, Global.Tree]

   Map a specializable method to its rhs, when not deferred.

10.  def clone(): AnyRef
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
11.  var curTree: Global.Tree
    Attributes
      protected
    Definition Classes
      TypingTransformer
12.  def currentClass: Global.Symbol
    Attributes
      protected
    Definition Classes
      Transformer
13.  def currentMethod: Global.Symbol
    Attributes
      protected
    Definition Classes
      Transformer
14.  var currentOwner: Global.Symbol
    Attributes
      protected[scala]
    Definition Classes
      Transformer
15.  def doesConform(origSymbol: Global.Symbol, treeType: Global.Type, memberType: Global.Type, env: TypeEnv): Boolean
16.  def ensuring(cond: (SpecializationTransformer) => Boolean, msg: => Any): SpecializationTransformer
    Implicit
      This member is added by an implicit conversion from SpecializationTransformer toEnsuring[SpecializationTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  def ensuring(cond: (SpecializationTransformer) => Boolean): SpecializationTransformer
    Implicit
      This member is added by an implicit conversion from SpecializationTransformer toEnsuring[SpecializationTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
18.  def ensuring(cond: Boolean, msg: => Any): SpecializationTransformer
    Implicit
      This member is added by an implicit conversion from SpecializationTransformer toEnsuring[SpecializationTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
19.  def ensuring(cond: Boolean): SpecializationTransformer
    Implicit
      This member is added by an implicit conversion from SpecializationTransformer toEnsuring[SpecializationTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
20.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
21.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
22.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
23.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from SpecializationTransformer toStringFormat[SpecializationTransformer] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
24.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
25.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
26.  def implSpecClasses(trees: List[Global.Tree]): List[Global.Tree]

    Create specialized class definitions

27.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
28.  var localTyper: (analyzer)#Typer
    Definition Classes
      TypingTransformer
29.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
30.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
31.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
32.  val parameters: AnyRefMap[Global.Symbol, List[Global.Symbol]]

    Map a specializable method to its value parameter symbols.

33.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
34.  def toString(): String
    Definition Classes
      AnyRef → Any
35.  def transform(tree: Global.Tree): Global.Tree
    Definition Classes
      SpecializationTransformer → TypingTransformer → InternalTransformer → Transformer
36.  def transformCaseDefs(trees: List[Global.CaseDef]): List[Global.CaseDef]
    Definition Classes
      Transformer
37.  def transformIdents(trees: List[Global.Ident]): List[Global.Ident]
    Definition Classes
      Transformer
38.  def transformMemberDefs(trees: List[Global.MemberDef]): List[Global.MemberDef]
    Definition Classes
      Transformer
39.  def transformModifiers(mods: Global.Modifiers): Global.Modifiers
    Definition Classes
      Transformer
40.  def transformStats(stats: List[Global.Tree], exprOwner: Global.Symbol): List[Global.Tree]
    Definition Classes
      Transformer
41.  def transformTemplate(tree: Global.Template): Global.Template
    Definition Classes
      Transformer
42.  def transformTrees(trees: List[Global.Tree]): List[Global.Tree]
    Definition Classes
      Transformer
43.  def transformTypeDefs(trees: List[Global.TypeDef]): List[Global.TypeDef]
    Definition Classes
      Transformer
44.  def transformUnit(unit: Global.CompilationUnit): Unit
    Definition Classes
      SpecializationTransformer → Transformer
45.  def transformValDef(tree: Global.ValDef): Global.ValDef
    Definition Classes
      Transformer
46.  def transformValDefs(trees: List[Global.ValDef]): List[Global.ValDef]
    Definition Classes
      Transformer
47.  def transformValDefss(treess: List[List[Global.ValDef]]): List[List[Global.ValDef]]
    Definition Classes
      Transformer
48.  val treeCopy: Global.TreeCopier
    Definition Classes
      Transformer
49.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
50.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
51.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (SpecializationTransformer, B)
   Implicit
     This member is added by an implicit conversion from SpecializationTransformer toArrowAssoc[SpecializationTransformer] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from SpecializeTypes.TypingTransformer

### Inherited from Global.Transformer

### Inherited from Global.InternalTransformer

### Inherited from Global.Transformer

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromSpecializationTransformer to any2stringadd[SpecializationTransformer]

### Inherited by implicit conversion StringFormat fromSpecializationTransformer to StringFormat[SpecializationTransformer]

### Inherited by implicit conversion Ensuring fromSpecializationTransformer to Ensuring[SpecializationTransformer]

### Inherited by implicit conversion ArrowAssoc fromSpecializationTransformer to ArrowAssoc[SpecializationTransformer]

### Ungrouped